package acs.jaxrssamples.rs.webservices;

import java.util.List;

import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.transaction.UserTransaction;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;

import acs.jaxrssamples.jpa.Car;

@Path("/hello")
public class HelloWorldResource {
	
	@Inject
	private EntityManager entityManager;
	@Inject
	private UserTransaction userTransaction;

	@GET()
	@Produces("text/plain")
	public String sayHello() {
		StringBuilder result = new StringBuilder();
		try {
			userTransaction.begin();
			Car car = new Car();
			car.setCarName("Name: " + System.currentTimeMillis());
			entityManager.persist(car);
			
			Car car2 = new Car();
			car2.setCarName("Name: " + System.currentTimeMillis());
			entityManager.persist(car2);
			
			for (int i = 0; i < 900000; i++) {
				Query q = entityManager.createQuery("select c from Car c");
				List<Car> resultList = q.getResultList();
				for (Car c : resultList) {
					result.append("Car: ").append(c.getCarPk()).append(", ").append(c.getCarName()).append("\n");
				}
				result = new StringBuilder();
			}
			
			Query q = entityManager.createQuery("select c from Car c");
			List<Car> resultList = q.getResultList();
			for (Car c : resultList) {
				result.append("Car: ").append(c.getCarPk()).append(", ").append(c.getCarName()).append("\n");
			}
			
			result.append("\n\n\nSecond Query:\n");
			q = entityManager.createQuery("select c from Car c");
			resultList = q.getResultList();
			for (Car c : resultList) {
				result.append("Car: ").append(c.getCarPk()).append(", ").append(c.getCarName()).append("\n");
			}
			
			result.append("\n\n\nThird Query:\n");
			q = entityManager.createQuery("select c from Car c");
			resultList = q.getResultList();
			for (Car c : resultList) {
				result.append("Car: ").append(c.getCarPk()).append(", ").append(c.getCarName()).append("\n");
			}
			
			result.append("\n\n\nFourth Query:\n");
			q = entityManager.createQuery("select c from Car c");
			resultList = q.getResultList();
			for (Car c : resultList) {
				result.append("Car: ").append(c.getCarPk()).append(", ").append(c.getCarName()).append("\n");
			}
			
			userTransaction.commit();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	    return "Hello World!\n\nCars:\n" + result.toString();
	}
}
